<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'GetCoursesBySectionNumber' => '\\StructType\\GetCoursesBySectionNumber',
            'GetCoursesBySectionNumberResponse' => '\\StructType\\GetCoursesBySectionNumberResponse',
            'CourseCodesResponse' => '\\StructType\\CourseCodesResponse',
            'Result' => '\\StructType\\Result',
            'ArrayOfError' => '\\ArrayType\\ArrayOfError',
            'Error' => '\\StructType\\Error',
            'ArrayOfString' => '\\ArrayType\\ArrayOfString',
            'GetCourseStandardPrices' => '\\StructType\\GetCourseStandardPrices',
            'GetCourseStandardPricesResponse' => '\\StructType\\GetCourseStandardPricesResponse',
            'CourseStandardPricesResponse' => '\\StructType\\CourseStandardPricesResponse',
            'ArrayOfCourseStandardPrice' => '\\ArrayType\\ArrayOfCourseStandardPrice',
            'CourseStandardPrice' => '\\StructType\\CourseStandardPrice',
            'Price' => '\\StructType\\Price',
            'GetOfferedCoursePrices' => '\\StructType\\GetOfferedCoursePrices',
            'GetOfferedCoursePricesResponse' => '\\StructType\\GetOfferedCoursePricesResponse',
            'OfferedCoursePricesResponse' => '\\StructType\\OfferedCoursePricesResponse',
            'ArrayOfCoursePrice' => '\\ArrayType\\ArrayOfCoursePrice',
            'CoursePrice' => '\\StructType\\CoursePrice',
            'Date' => '\\StructType\\Date',
            'GetOfferedCourses' => '\\StructType\\GetOfferedCourses',
            'GetOfferedCoursesResponse' => '\\StructType\\GetOfferedCoursesResponse',
            'GetSettings' => '\\StructType\\GetSettings',
            'GetSettingsResponse' => '\\StructType\\GetSettingsResponse',
            'PriceSettingsResponse' => '\\StructType\\PriceSettingsResponse',
            'GetUnofferedCourses' => '\\StructType\\GetUnofferedCourses',
            'GetUnofferedCoursesResponse' => '\\StructType\\GetUnofferedCoursesResponse',
            'RemoveOfferedCourses' => '\\StructType\\RemoveOfferedCourses',
            'MonthRange' => '\\StructType\\MonthRange',
            'RemoveOfferedCoursesResponse' => '\\StructType\\RemoveOfferedCoursesResponse',
            'Response' => '\\StructType\\Response',
            'SetCoursePrice' => '\\StructType\\SetCoursePrice',
            'SetCoursePriceResponse' => '\\StructType\\SetCoursePriceResponse',
            'SetCourseSectionNumber' => '\\StructType\\SetCourseSectionNumber',
            'SetCourseSectionNumberResponse' => '\\StructType\\SetCourseSectionNumberResponse',
        );
    }
}
